/*
 * MIT License
 *
 * Copyright (c) 2020 Alexey Edelev <semlanik@gmail.com>
 *
 * This file is part of QtProtobuf project https://git.semlanik.org/semlanik/qtprotobuf
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this
 * software and associated documentation files (the "Software"), to deal in the Software
 * without restriction, including without limitation the rights to use, copy, modify,
 * merge, publish, distribute, sublicense, and/or sell copies of the Software, and
 * to permit persons to whom the Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies
 * or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
 * FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#include "duplicated_metatypes.qpb.h"

#include <QtTest/QtTest>
#include <qtprotobuftestscommon.h>

class QtProtobufDuplicatedMetatypesTest : public QObject
{
    Q_OBJECT
public:
    QtProtobufDuplicatedMetatypesTest()
    {
        qRegisterProtobufTypes();
    }
private slots:
    void SimpleTest();
};

using namespace qtprotobufnamespace::duplicated_metatypes;

void QtProtobufDuplicatedMetatypesTest::SimpleTest()
{
    qProtobufAssertMessagePropertyRegistered<Message1, Message1::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message1::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message2, Message2::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message2::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message3, Message3::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message3::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message4, Message4::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message4::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message5, Message5::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message5::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message6, Message6::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message6::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message7, Message7::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message7::OptsEntry", "opts");
    qProtobufAssertMessagePropertyRegistered<Message8, Message8::OptsEntry>(1, "qtprotobufnamespace::duplicated_metatypes::Message8::OptsEntry", "opts");
}

#include "duplicatedmetatypestest.moc"
QTEST_MAIN(QtProtobufDuplicatedMetatypesTest)
